"""
This module is designed to process the vcf files from the
snp folder.  
"""

import pandas as pd 
import os 

def crop_vcf(filename):
    """
    This funciton will read in a a vcf file and remove the leading comments
    it returns a string of the tab-delimited table
    """
    with open(filename, "r") as openfile: 
        content = openfile.read().split("\n")
    
    # remove comments headed by ##
    content = [i for i in content if not i.startswith("##")]
    # trim the #CHROM to just CHROM (start of table)
    content[0] = content[0][1:]
    content = "\n".join(content)
    with open(f"{filename}_cropped", "w") as openfile: 
        openfile.write(content)

def read_vcf(filename, keep = False):
    """
    This function will read in the raw_string generated by read_vcf and generate a df 
    """
    crop_vcf(filename)
    cropped = f"{filename}_cropped"
    df = pd.read_table(cropped, sep = "\t")
    df = df.to_dict(orient="list")

    if keep == False: 
        os.remove(cropped)

    df = _update_data(df)
    return df

def _update_data(df):
    """
    This function will extract info from the INFO column 
    to add to the overall dataframe and make the info searchable

    Check out the extract_from_info fuction for more info
    """
    new_df = {}

    for i in df["INFO"]:
        
        extracted_infos = _extract_from_info(i)
        for i in extracted_infos:
            val = extracted_infos[i]
            if i not in new_df:
                new_df[i] = [val]
            else: 
                new_df[i].append(val)

    
    df.update(new_df)
    df = pd.DataFrame(df)
    return df


INFO_STATS = {
    "type" : 1, 
    "impact" : 2, 
    "gene" : 4, 
    "dphen" : 9, 
    "pphen" : 10,
}

def _extract_from_info(row):
    """ 
    This function extracts information from INFO column
    It will extract all entries specified inthe INFO_STATS
    """    
    tmp = row.split("|")
    results = {}
    for stat, idx in zip(list(INFO_STATS.keys()), list(INFO_STATS.values())): 
        
        results.update(
            {stat : tmp[idx]}
        )

    return results


def combine_dfs(df_dict):
    """
    This function combines separate DFs for the mutants into a single one, 
    adding a name column with the mutant identifier
    """

    for i in df_dict:
        names = [i for j in range(len(df_dict[i]["CHROM"]))]
        df_dict[i]["name"] = names

    new_df  = list(df_dict.values())
    new_df =  pd.concat(new_df, ignore_index=True)
    return new_df

def drop_bams(df):
    """
    This function will remove the .bam columns as well as columns FORMAT and FILTER
    from the df as they do not contribute any useful information.
    """
    to_drop = [i for i in list(df.keys()) if (".bam" in i or i in ["FORMAT", "FILTER"])]
   
    new = df.drop(to_drop, axis = 1)
        
    return new

def drop_info(df):
    """
    Will drop the not so useful INFO column
    """
    df = df.drop("INFO", axis = 1)
    return df 


def gquery(df, groups:list, query=None, add_count=False): 
   """
   >> This function is deprecated! <<
   This function will perform a query based on grouped dataframes, 
   so that combinations of the can be selected and returns a sub-sliced dataframe

   It is supposed to primarily work within the Frame class but can (of course) function on any pandas dataframe
   """
   if query is None: query = "count >= 1"
   
   # to keep track of the counts in each 
   counts = []

   results =[]
   for i in list(set(df["name"])):
      # get the appropriate sub_df
      tmp = df.query(f"name == '{i}'")

      # get indices of matching values
      q = tmp.groupby(
                        groups
                        ).size().reset_index().rename(columns={0:'count'}).query(
                           query
                     ).index.values
      q = list(q)

      result = tmp.iloc[q]
      results.append(result)
   results = pd.concat(results)
   return results

def getnames(df, uniq=True):
    """
    This function returns a \n-joined string of the entries in the "gene" column of df
    It is useful for writing to files or printing out so the names can be forwarded for GO Terma analysis. 
    """
    s = list(df["gene"])
    if uniq: 
        s = list(set(s))
    s = "\n".join(s)
    return s

class Frame:
    """
    This class will handle the above functions and wrap them neatly together, 
    it is supposed to facilitate usage of this module but not required. 
    """
    def __init__(self, name, filename):
        self.name = name
        self._SOURCE = filename
        self._df = read_vcf(self._SOURCE)
        self._df = drop_bams(self._df)
        self._orig = None
    
    def merge(self, *Frames):
        """
        This function allows to merge multiple Frame object's dfs into the one that has called merge
        """
        # in case a list of frames was provided we want to have the list and not a tuple containing that one list...
        if isinstance(Frames[0], (list, tuple)): 
            Frames = Frames[0]
        new_df = { self.name : self._df}
        for i in Frames: 
            new_df.update(
                {i.name : i.get() }
                )
        new_df = combine_dfs(new_df)
        self._df = new_df

    def gquery(self, groups, query=None, add_count = False):
        """Integrated gquery function"""
        return gquery(self._df, groups, query, add_count)

    def update(self, df):
        """
        This function will allow to update the self._df after it has been modified using pandas outside of this class. 
        This function will store a copy of the original self._df as self._orig 
        """
        if self._orig is None: 
            self._orig = self._df
        self._df = df 

    def drop_info(self):
        self._df = drop_info(self._df)

    def get(self):
        return self._df
    
    

if __name__ == '__main__':
    f = "/Volumes/MicroExtend/GIT/bioinf_practical_hs21/data/snp/D6_S142.bam.vcf_filtered_to_3.vcf"
    read_vcf(f)